NB. Plugin
NB. random.ijs
NB. Random number plug-in

coclass 'random'
(;:'base z') copath 'random'

NB. Define menu item for plug-in

MENU=: 0 : 0
menu Rand "&Random numbers..." "" "Random number generator" "Random number generator";
)

NB. menu button in base locale

mstat_Rand_button__=: open_random_

NB. Dialog definition

RAND=: 0 : 0
pc rand dialog nosize escclose closeok;pn "Random number generator";
bin v;
groupbox "Type";
cc rb0 radiobutton;cn "&Uniform integers";
cc rb1 radiobutton group;cn "&Normal";
groupboxend;

bin h;
groupbox "Normal";
bin v;
bin h;
minwh 80 32;cc lm static right;cn "Mean ";
cc mean edit;set mean wh 60 _1;
bin z;
bin h;
minwh 80 32;cc lv static right;cn "Variance ";
cc variance edit;set variance wh 60 _1;
bin z;
bin z;
groupboxend;
groupbox "Uniform";
bin v;
bin h;
minwh 80 32;cc lmin static right;cn "Minimum ";
cc umin edit;set umin wh 60 _1;
bin z;
bin h;
minwh 80 32;cc lmax static right;cn "Maximum ";
cc umax edit;set umax wh 60 _1;
bin z;
bin z;
groupboxend;
bin z;

bin h;
cc spc static;cn "";set spc wh 80 32;
cc labelns static right;cn "Number of samples  ";
cc numrand edit;set numrand wh 60 _1;
bin sz;

bin h;
cc spc2 static;cn "";set spc2 wh 80 32;
cc varcb checkbox;cn "&Assign to variable  ";
bin sz;

bin h;
cc label static right;cn "Variable name";
cc var edit;
bin z;

bin hs2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;

)


NB. Static variables

MakeVar=: 0
VarType=: 0

NB. Code

open=: 3 : 0
wd RAND
wd 'set rb',(":VarType),' 1'
if. MakeVar do. 
  wd 'set varcb value 1'
  wd 'set var enable' 
else. 
  wd 'set varcb value 0'
  wd 'set var enable 0'
end.
setVarType''
wd 'pshow;'
)

close=: 3 : 0
wd'pclose'
)

rand_cancel_button=: rand_close=: rand_cancel=: close

rand_varcb_button=: 3 : 0
if. MakeVar do.
  MakeVar=: 0
  wd 'set varcb value 0'
  wd 'set var enable 0'
else.
  MakeVar=: 1
  wd 'set varcb value 1'
  wd 'set var enable 1'
end.
)

rand_rb0_button=: 3 : 0
VarType=: 0
setVarType''
)

rand_rb1_button=: 3 : 0
VarType=: 1
setVarType''
)

rand_ok_button=: 3 : 0
if. MakeVar do.
  Vn=. var
  if. e=.'v' invalidVn Vn do.
    vnError e
    wd 'set var focus'
    return.
  end.
end.
if. -. ValidN numrand do. 
  wd'set numrand focus'
  return.
end.
n=. ". numrand
if. VarType do.
  if. -. ValidN mean do. 
    wd'set mean focus'
    return.
  end.
  m=. ". mean
  if. -. ValidN variance do. 
    wd'set variance focus'
    return.
  end.
  v=. ". variance
  r=. (m;v^0.5) nrand n
  head=. (": n),' random normal variates'
else.
  if. -. ValidN umin do. 
    wd'set umin focus'
    return.
  end.
  min=. ". umin
  if. -. ValidN umax do. 
    wd'set umax focus'
    return.
  end.
  max=. ". umax
  if. max <: min do.
    mbError 'Invalid value';'Max must be larger than Min'
    wd 'set umax focus'
    return.
  end.
  r=. (min;max) urand n
  head=. (": n),' random integers between ',(":min),' and ',":max
end.
tout head,LF
tout ,vfm 50 list ft r
tout LF
if. MakeVar do. 
  ". (locv Vn),'=: ',":r
  tout 'Assigned to variable ',Vn,LF,LF
else.
  tout LF
end.
close''
view''
)

setVarType=: 3 : 0
if. VarType do.
  wd 'set mean enable; set variance enable; set lm enable; set lv enable'
  wd 'set umin enable 0; set umax enable 0; set lmin enable 0; set lmax enable 0'
else.
  wd 'set umin enable; set umax enable; set lmin enable; set lmax enable'
  wd 'set mean enable 0; set variance enable 0; set lm enable 0; set lv enable 0'
end.
)

ValidN=: 3 : 0
if. 0=#y do.
  mbError 'Missing value';'You must enter a value.'
  ret=. 0
  return.
end.
n=. __ ". y
if. ((<,y) e. (,'-');,'_') +. n=__ do.
  mbError'Invalid value';'You must enter a valid number.'
  ret=. 0
  return.
end.
ret=. 1
)

rn =: (>:@? % 2147483647&[) @ $ & 2147483646

nrand =: 4 : 0
NB. x is mean;sd
NB. y is number of values desired
'm s'=.x
p =. rn y
z =. invnorm 1-p
m+z*s
)

urand=: 4 : 0
NB. x is min;max
NB. y is number of values desired
'min max'=. x
m=.min-1
p=. rn y
>.m+(max-m)*p
)

rand_var_button=: rand_ok_button

rand_octrl_fkey=: rand_ok_button
